#include <amxmodx>
#include <cstrike>
#include <fakemeta>
#include <zombieplague>

#define VERSION "1.0"

new const sound[] = "hglaser.wav"

// Item IDs
new g_laser, g_can[33], shots, laser, sync, g_shots[33]
new g_msgDeathMsg, g_msgScoreAttrib, g_msgScoreInfo

new pointer[2]

public plugin_init()
{
	/* Plugin Registery */
	register_plugin("[ZP] Antidote Laser", VERSION, "ILUSION")
	
	register_forward(FM_PlayerPreThink, "fw_PlayerPreThink")
	
	register_cvar("zp_lasers", VERSION, FCVAR_SERVER)
	
	/* Language File */
	register_dictionary("zp_laser.txt")
	
	/* Cvars */
	g_laser = zp_register_extra_item("Antidote Laser", 15, ZP_TEAM_HUMAN)
	shots = register_cvar("zp_laser_shots", "3")
	sync = CreateHudSyncObj()
	g_msgDeathMsg = get_user_msgid("DeathMsg")
	g_msgScoreAttrib = get_user_msgid("ScoreAttrib")
	g_msgScoreInfo = get_user_msgid("ScoreInfo")
	
	pointer[0] = get_cvar_pointer("zp_human_frags_for_kill")
	pointer[1] = get_cvar_pointer("zp_zombie_infect_reward")
}

public plugin_precache()
{
	laser = precache_model("sprites/laserbeam.spr")
	precache_sound(sound)
}

public client_putinserver(id)
{
	g_can[id] = false
	g_shots[id] = false
}

public client_disconnect(id)
{
	g_can[id] = false
	g_shots[id] = false
}

// Item Selected forward
public zp_extra_item_selected(id, itemid)
{
	if (itemid == g_laser)
	{
		g_can[id] = true
		g_shots[id] = 0
	}
}

public zp_user_infected_pre(id, infector)
{
	g_can[id] = false
}

public fw_PlayerPreThink(id)
{
	if(g_can[id] && !zp_is_swarm_round() && !zp_is_nemesis_round() && !zp_is_plague_round())
	{
		if(pev(id, pev_button) & IN_USE)
		{
			if(!(pev(id, pev_oldbuttons) & IN_USE))
			{
				set_hudmessage(0, 128, 255, -1.0, 0.17, 1, 0.0, 3.0, 1.0, 1.0, -1)
				
				if (g_shots[id] >= get_pcvar_num(shots) || !is_user_alive(id))
				{
					client_print(id, print_chat, "[ZP] %L", id, "CANNOT")
					g_can[id] = false
					return FMRES_IGNORED
				}
								
				new ofin[3], name[32]
				get_user_origin(id, ofin, 3)
				efecto(id, ofin) 
				
				new target, temp, name2[32]
				get_user_aiming(id, target, temp, 9999)
				get_user_name(id, name, sizeof name - 1)
				get_user_name(target, name2, sizeof name2 - 1)
						
				if (is_user_alive(target) && zp_get_user_zombie(target) && !zp_get_user_last_zombie(target) && !zp_get_user_nemesis(target))
				{	
					/* zombie plague */
					SendDeathMsg(id, target) // send death notice
					FixDeadAttrib(target) // fix the "dead" attrib on scoreboard
					UpdateFrags(id, target, get_pcvar_num(pointer[0]), 1, 1) // add corresponding frags & deaths
					/* zombie plague */
					desinfectar(target)
					zp_disinfect_user(target)
					new ammo = zp_get_user_ammo_packs(id)
					zp_set_user_ammo_packs(id, ammo + get_pcvar_num(pointer[1]))
					client_print(0, print_chat, "[ZP] %L", id, "DISINFECT", name, name2)
				}
				
				g_shots[id]++
				
				ShowSyncHudMsg(id, sync, "[ZP] %L", id, "SHOTS_LEFT", g_shots[id], get_pcvar_num(shots))
			}
		}
	}
	
	return FMRES_IGNORED
}

public efecto(id, ofin[3])
{
	engfunc(EngFunc_EmitSound, id, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	new origin[3]
	get_user_origin(id, origin, 1)
	
	message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
	write_byte(27)
	write_coord(origin[0]) // x
	write_coord(origin[1]) // y
	write_coord(origin[2]) // z
	write_byte(40) 
	write_byte(0) // r
	write_byte(128) // g
	write_byte(255) // b
	write_byte(100)
	write_byte(10)
	write_byte(1)
	message_end()

	message_begin(MSG_PVS, SVC_TEMPENTITY)
	write_byte(0)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_coord(ofin[0])
	write_coord(ofin[1])
	write_coord(ofin[2])
	write_short(laser) 
	write_byte(5)
	write_byte(5)
	write_byte(3)
	write_byte(25)
	write_byte(5)
	write_byte(0)
	write_byte(128)
	write_byte(255)
	write_byte(100)
	write_byte(200)
	message_end()
	
	message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
	write_byte(14)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_byte(240)
	write_byte(120)
	write_byte(5) 
	message_end()
}

public desinfectar(target)
{
	new origin[3]
	get_user_origin(target, origin, 1)
	
	message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
	write_byte(14)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_byte(240)
	write_byte(120)
	write_byte(5) 
	message_end()
}

// zombie plague
SendDeathMsg(attacker, victim)
{
	message_begin(MSG_BROADCAST, g_msgDeathMsg)
	write_byte(attacker) // killer
	write_byte(victim) // victim
	write_byte(1) // headshot flag
	write_string("antidote laser") // killer's weapon
	message_end()
}

FixDeadAttrib(id)
{
	message_begin(MSG_BROADCAST, g_msgScoreAttrib)
	write_byte(id) // id
	write_byte(0) // attrib
	message_end()
}

UpdateFrags(attacker, victim, frags, deaths, scoreboard)
{
	// Set attacker frags
	set_pev(attacker, pev_frags, float(pev(attacker, pev_frags) + frags))
	
	// Set victim deaths
	cs_set_user_deaths(victim, cs_get_user_deaths(victim) + deaths)
	
	// Update scoreboard with attacker and victim info
	if (scoreboard)
	{
		message_begin(MSG_BROADCAST, g_msgScoreInfo)
		write_byte(attacker) // id
		write_short(pev(attacker, pev_frags)) // frags
		write_short(cs_get_user_deaths(attacker)) // deaths
		write_short(0) // class?
		write_short(get_user_team(attacker)) // team
		message_end()
		
		message_begin(MSG_BROADCAST, g_msgScoreInfo)
		write_byte(victim) // id
		write_short(pev(victim, pev_frags)) // frags
		write_short(cs_get_user_deaths(victim)) // deaths
		write_short(0) // class?
		write_short(get_user_team(victim)) // team
		message_end()
	}
}
